<template>
  <div class="app-sort">
    <div class="input-group">
      <div v-if="name" class="input-group-prepend">
        <span class="input-group-text">{{ name }}</span>
      </div>
      <select
        :value="value"
        class="form-control"
        :disabled="disabled"
        @change="onSortChange(+$event.target.value)"
      >
        <option v-if="placeholder" value="" selected="selected">
          {{ placeholder }}
        </option>
        <option
          v-for="item in list"
          :key="item.id"
          :value="item.id"
        >
          {{ item.label }}
        </option>
      </select>
    </div>
  </div>
</template>

<style lang="scss" scoped>
  .app-pagination {
    /deep/ {
      margin-top: 0.5rem;
      margin-bottom: 0.5rem;
    }
  }
</style>

<script>
const EVENT_SORT_CHANGE = 'sort-change'

export default {
  props: {
    /**
     * Sort list
     */
    list: {
      type: Array,
      default: () => []
    },

    /**
     * Value
     */
    value: {
      type: Number,
      default: null
    },

    /**
     * Name
     */
    name: {
      type: String,
      default: 'ソート'
    },

    /**
     * Placeholder
     */
    placeholder: {
      type: String,
      default: ''
    },

    /**
     * Disabled status
     */
    disabled: {
      type: Boolean,
      default: false
    }
  },

  methods: {
    /**
     * Event when change sort
     *
     * @param {Number} id - Sort id
     */
    onSortChange (id) {
      this.$emit(EVENT_SORT_CHANGE, id)
    }
  }
}
</script>
